---
title: Mobile touch controls
slug: Games/Techniques/Control_mechanisms/Mobile_touch
tags:
  - Controls
  - Games
  - JavaScript
  - Mobile
  - pointer
  - touch
---
<div>{{GamesSidebar}}</div>

<p>{{NextMenu("Games/Techniques/Control_mechanisms/Desktop_with_mouse_and_keyboard", "Games/Techniques/Control_mechanisms")}}</p>

<p class="summary">The future of mobile gaming is definitely web, and many developers choose the <a href="/en-US/docs/Web/Apps/Mobile_First">mobile first</a> approach in their game development process — in the modern world, this generally also involves implementing touch controls. In this tutorial, we will see how easy it is to implement mobile controls in an HTML5 game, and enjoy playing on a mobile touch-enabled device.</p>

<p class="note"><strong>Note</strong>: The game <a class="external external-icon" href="http://rogers2.enclavegames.com/demo/">Captain Rogers: Battle at Andromeda</a> is built with Phaser and managing the controls is Phaser-based, but it could also be done in pure JavaScript. The good thing about using Phaser is that it offers helper variables and functions for easier and faster development, but it's entirely up to you which approach you to choose.</p>

<h2 id="Pure_JavaScript_approach">Pure JavaScript approach</h2>

<p>We could implement touch events on our own — setting up event listeners and assigning relevant functions to them would be quite straightforward:</p>

<pre class="brush: js notranslate">var el = document.getElementsByTagName("canvas")[0];
el.addEventListener("touchstart", handleStart);
el.addEventListener("touchmove", handleMove);
el.addEventListener("touchend", handleEnd);
el.addEventListener("touchcancel", handleCancel);</pre>

<p>This way, touching the game's {{htmlelement("canvas")}} on the mobile screen would emit events, and thus we could manipulate the game in any way we want (for example, moving the space ship around). The events are as follows:</p>

<ul>
 <li><a href="/en-US/docs/Web/API/GlobalEventHandlers/ontouchstart">touchstart</a> is fired when the user puts a finger on the screen.</li>
 <li><a href="/en-US/docs/Web/API/GlobalEventHandlers/ontouchmove">touchmove</a> is fired when they move the finger on the screen while touching it</li>
 <li><a href="/en-US/docs/Web/API/GlobalEventHandlers/ontouchend">touchend</a> is fired when the user stops touching the screen</li>
 <li><a href="/en-US/docs/Web/API/GlobalEventHandlers/ontouchcancel">touchcancel</a> is fired when a touch is cancelled, for example when the user moves their finger outside of the screen.</li>
</ul>

<div class="note">
<p><strong>Note</strong>: The <a href="/en-US/docs/Web/API/Touch_events">touch events</a> reference article provides more examples and information.</p>
</div>

<h3 id="Pure_JavaScript_demo">Pure JavaScript demo</h3>

<p>Let's implement the mobile support in a <a href="https://github.com/end3r/JavaScript-Game-Controls/">little demo</a> available on GitHub, so we can move the player's ship by touching the screen on a mobile device.</p>

<p>We will use two events: <code>touchstart </code>and,<code>touchmove</code> both handled by one function. Why? The function <code>touchHandler</code> will assign proper variables to the ship's position so that we can use it for both cases: when the player touches the screen but doesn't move it (<code>touchstart</code>), and when the finger is moved on the screen (<code>touchmove</code>):</p>

<pre class="brush: js notranslate">document.addEventListener("touchstart", touchHandler);
document.addEventListener("touchmove", touchHandler);</pre>

<p>The <code>touchHandler</code> function looks like this:</p>

<pre class="brush: js notranslate">function touchHandler(e) {
    if(e.touches) {
        playerX = e.touches[0].pageX - canvas.offsetLeft - playerWidth / 2;
        playerY = e.touches[0].pageY - canvas.offsetTop - playerHeight / 2;
        output.textContent = `Touch:  x: ${playerX}, y: ${playerY}`;
        e.preventDefault();
    }
}</pre>

<p>If the touch occurs (<code>touches</code> object is not empty), then we will have all the info we need in that object. We can get the first touch (<code>e.touches[0]</code>, our example is not multitouch-enabled), extract the <code>pageX</code> and <code>pageY</code> variables and set the player's ship position on the screen by subtracting the Canvas offset (distance from the Canvas and the edge of the screen) and half the player's width and height.</p>

<p><img alt="Touch controls for the player's ship, with visible output of the x and y position." src="https://mdn.mozillademos.org/files/14201/controls-touch.png" style="border-style: solid; border-width: 1px; display: block; height: 436px; margin: 0px auto; width: 575px;"></p>

<p>To see if it's working correctly we can output the <code>x</code> and <code>y</code> positions using the <code>output</code> element. The <code>preventDefault()</code> function is needed to prevent the browser from moving — without it you'd have the default behaviour, and the Canvas would be dragged around the page, which would show the browser scroll bars and look messy.</p>

<h2 id="Touch_events_in_Phaser">Touch events in Phaser</h2>

<p>We don't have to do this on our own; frameworks like Phaser offer systems for managing touch events for us — see <a href="http://phaser.io/docs/2.6.1/Phaser.Touch.html">managing the touch events</a>.</p>

<h3 id="Pointer_theory">Pointer theory</h3>

<p>A <a href="http://phaser.io/docs/2.6.1/Phaser.Pointer.html">pointer</a> represents a single finger on the touch screen. Phaser starts two pointers by default, so two fingers can perform an action at once. Captain Rogers is a simple game — it can be controlled by two fingers, the left one moving the ship and the right one controlling the ship's gun. There's no multitouch or gestures — everything is handled by single pointer inputs.</p>

<p>You can add more pointers to the game by using; <code>this.game.input.addPointer</code> up to ten pointers can be managed simultaneously. The most recently used pointer is available in the <code>this.game.input.activePointer</code> object — the most recent finger active on the screen.</p>

<p>If you need to access a specific pointer, they are all available at, <code>this.game.input.pointer1</code><code>this.game.input.pointer2</code>, etc. They are assigned dynamically, so if you put three fingers on the screen, then, <code>pointer1</code><code>pointer2</code>, and <code>pointer3</code> will be active. Removing the second finger, for example, won't affect the other two, and setting it back again will use the first available property, so <code>pointer2</code> will be used again.</p>

<p>You can quickly get the coordinates of the most recently active pointer via the <code>this.game.input.x</code> and <code>this.game.input.y</code> variables.</p>

<h3 id="Input_events">Input events</h3>

<p>Instead of using the pointers directly it is also possible to listen for <code>this.game.input</code> events, like <code>onDown</code>, <code>onUp</code>, <code>onTap</code> and <code>onHold</code>:</p>

<pre class="brush: js notranslate">this.game.input.onDown.add(itemTouched, this);

function itemTouched(pointer) {
    // do something
}</pre>

<p>The <code>itemTouched()</code> function will be executed when the <code>onDown</code> event is dispatched by touching the screen. The <code>pointer</code> variable will contain the information about the pointer that activated the event.</p>

<p>This approach uses the generally available <code>this.game.input</code> object, but you can also detect the actions on any game objects like sprites or buttons by using <code>onInputOver</code>, <code>onInputOut</code>, <code>onInputDown</code>, <code>onInputUp</code>, <code>onDragStart</code>, or <code>onDragStop</code>:</p>

<pre class="brush: js notranslate">this.button.events.onInputOver.add(itemTouched, this);

function itemTouched(button, pointer) {
    // do something
}</pre>

<p>That way you'll be able to attach an event to any object in the game, like the player's ship, and react to the actions performed by the user.</p>

<p>An additional advantage of using Phaser is that the buttons you create will take any type of input, whether it's a touch on mobile or a click on desktop — the framework sorts this out in the background for you.</p>

<h3 id="Implementation">Implementation</h3>

<p>The easiest way to add an interactive object that will listen for user input is to create a button:</p>

<pre class="brush: js notranslate">var buttonEnclave = this.add.button(10, 10, 'logo-enclave', this.clickEnclave, this);</pre>

<p>This one is formed in the <code>MainMenu</code> state — it will be placed ten pixels from the top left corner of the screen, use the <code>logo-enclave</code> image, and execute the <code>clickEnclave()</code> function when it is touched. This will work on mobile and desktop out of the box. There are a few buttons in the main menu, including the one that will start the game.</p>

<p>For the actual gameplay, instead of creating more buttons and covering the small mobile screen with them, we can use something a little bit different: we'll create invisible areas which respond to the given action. From a design point of view, it is better to make the field of activity bigger without covering half of the screen with button images. For example, tapping on the right side of the screen will fire the weapon:</p>

<pre class="brush: js notranslate">this.buttonShoot = this.add.button(this.world.width*0.5, 0, 'button-alpha', null, this);
this.buttonShoot.onInputDown.add(this.goShootPressed, this);
this.buttonShoot.onInputUp.add(this.goShootReleased, this);</pre>

<p>The code above will create a new button using a transparent image that covers the right half of the screen. You can assign functions on input down and input up separately if you'd like to perform more complicated actions, but in this game touching the right side of the screen will fire the bullets to the right — this is all we need in this case.</p>

<p>Moving the player could be managed by creating the four directional buttons, but we can take the advantage of touch screens and drag the player's ship around:</p>

<pre class="brush: js notranslate">var player = this.game.add.sprite(30, 30, 'ship');
player.inputEnabled = true;
player.input.enableDrag();
player.events.onDragStart.add(onDragStart, this);
player.events.onDragStop.add(onDragStop, this);

function onDragStart(sprite, pointer) {
    // do something when dragging
}</pre>

<p>We can pull the ship around and do something in the meantime, and react when the drag is stopped. Hauling in Phaser, if enabled, will work out of the box — you don't have to set the position of the sprite yourself manually, so you could leave the <code>onDragStart()</code> function empty, or place some debug output to see if it's working correctly. The <code>pointer</code> element contains the <code>x</code> and <code>y</code> variables storing the current position of the dragged element.</p>

<h3 id="Dedicated_plugins">Dedicated plugins</h3>

<p>You could go even further and use dedicated plugins like <a href="http://phaser.io/shop/plugins/virtualjoystick">Virtual Joystick</a> — this is a paid, official Phaser plugin, but you can find free and <a href="https://github.com/Gamegur-us/phaser-touch-control-plugin">open source alternatives</a>. The initialization of Virtual Joystick looks like this:</p>

<pre class="brush: js notranslate">this.pad = this.game.plugins.add(Phaser.VirtualJoystick);
this.stick = this.pad.addStick(30, 30, 80, 'generic');</pre>

<p>In the <code>create()</code> function of the <code>Game</code> state we're creating a virtual pad and a generic stick that has four directional virtual buttons by default. This is placed 30 pixels from the top and left edges of the screen and is 80 pixels wide.</p>

<p>The stick being pressed can be handled during the gameplay in the <code>update</code> function like so:</p>

<pre class="brush: js notranslate">if(this.stick.isDown) {
    // move the player
}</pre>

<p>We can adjust the player's velocity based on the current angle of the stick and move him appropriately.</p>

<h2 id="Summary">Summary</h2>

<p>That covers adding touch controls for mobile; in the next article we'll see how to add keyboard and mouse support.</p>

<p>{{NextMenu("Games/Techniques/Control_mechanisms/Desktop_with_mouse_and_keyboard", "Games/Techniques/Control_mechanisms")}}</p>
